/**
  ******************************************************************************
  * File    ICS sample file for T5401-STM32F303xx
  * Version V1.0.0
  * Date    9-April-2017
  ******************************************************************************
  *
  * COPYRIGHT 2017 IAR systems
  *
  ******************************************************************************
  */

#include "stm32f30x.h"
#include "math.h"
#include "ICS2_STM32F30x.h"
#include "control.h"


#define  TWOPI   (3.14159265f*2.0f)


float   wt   = 0.0f;
float   refu = 0.0f;
float   refv = 0.0f;
float   refw = 0.0f;
float   freq = 50.0f;
float   m    = 1.0f;

int8_t up    = 0;
int8_t a8    = 0;
int8_t b8    = 0;
int8_t c8    = 0;
int8_t d8    = 0;

void  control(void)
{
    wt = wt + freq * TWOPI / (1.0f/100.0e-6);
    if (wt>=TWOPI) { wt = wt - TWOPI; }
    
    if (up==1)     { m = m + 0.00001; }
    else           { m = m - 0.00001; }

    if      (m>=1.0f)   { up = 0; }
    else if (m<0.8f)    { up = 1; }

    refu = m * sinf(wt);
    refv = m * sinf(wt-TWOPI*1.0f/3.0f);
    refw = m * sinf(wt-TWOPI*2.0f/3.0f);
    
    a8 = (int8_t)(10.0f * refu);
    b8 = (int8_t)(20.0f * refu);
    c8 = (int8_t)(40.0f * refu);
    d8 = (int8_t)(80.0f * refu);

    ics2_watchpoint();
}

/************************************************************** END OF FILE ***/
