/**
  ******************************************************************************
  * File    ICS sample file for Nucleo-F303RE
  * Version V1.0.0
  * Date    9-April-2017
  ******************************************************************************
  *
  * COPYRIGHT 2017 IAR systems
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "stm32f30x.h"
#include "ICS2_STM32F30x.h"
#include "stm32f30x_it.h"
#include "control.h"

/* Private variables ---------------------------------------------------------*/
__IO uint32_t Counter = 0x00;
extern uint32_t CCR1_Val;
uint32_t capture = 0;

/******************************************************************************/
/*            Cortex-M4 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief  This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{
}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
void DebugMon_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{
}

/**
* @brief  This function handles SysTick Handler.
* @param  None
* @retval None
*/
void SysTick_Handler(void)
{
    Counter++;

  // Interrupt for control
    control();           
}

/******************************************************************************/
/*                 STM32F30x Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_stm32f30x.s).                                            */
/******************************************************************************/

/**
* @brief  This function handles USART interrupt request.
* @param  None
* @retval None
*/
void USART1_IRQHandler(void)
{
    ics_int_sci_rxi();
}

void USART2_IRQHandler(void)
{
    ics_int_sci_rxi();
}

void USART3_IRQHandler(void)
{
    ics_int_sci_rxi();
}

void UART4_IRQHandler(void)
{
    ics_int_sci_rxi();  
}


/************************************************************** END OF FILE ***/
